%% test 1: very simple toy case
G = [0   0   0.9 0   0;
     0   0   0.9 0   0;
     0.9 0.9 0   0.7 0;
     0   0   0.7 0   0.9;
     0   0   0   0.9 0];

[label] = ntp(G,2);

%% test 2: the reproduction of the toy experiment in the paper, giving the
% result of Figure 3(a).

clear;
addpath([pwd '/3rd_party/ZPclustering']);
mex ./3rd_party/ZPclustering/scale_dist.cpp
load toydata/Data.mat XX;

X = XX{1};
clear XX;

% centralize and scale the data
X = X - repmat(mean(X),size(X,1),1);
X = X/max(max(abs(X)));

% Build affinity matrices
neighbor_num = 10;
D = dist2(X,X);              %% Euclidean distance
[D_LS,A_LS,LS] = scale_dist(D,floor(neighbor_num/2)); %% Locally scaled affinity matrix
clear D_LS; clear LS;

[Tree parents] = mst(-A_LS);
figure;
hold on;
for i = 1:length(parents)
    if parents(i) == 0
        continue;
    end
    pair = [i parents(i)];
    plot(X(pair,1),X(pair,2),'r-','Color',[A_LS(i,parents(i)) 0 0]);
end

[label] = ntp(A_LS,3);
scatter(X(:,1),X(:,2),20,label,'filled');
